''' 11 - Bases des graphes'''

## 11-3 - A star

## Algorithme A*

# Initialisation

Image_Anim = Image.copy() # Si animation
Distances = np.inf*np.ones([Nl,Nc])
Distances[ld,cd] = 0
Reste = Dico_Voisins.copy()
Provenances = {}

# heuristique
from math import sqrt
def heuristique (pt1 ,pt2 , type ):
    if type == 1:
        return abs(pt1 [0] - pt2 [0]) + abs(pt1 [1] - pt2 [1])
    if type == 2:
        return sqrt (( pt1 [0] - pt2 [0])**2 + (pt1 [1] - pt2 [1])**2)
    if type == 3:
        return sqrt (2)* min(abs(pt1 [0] - pt2 [0]) , abs(pt1 [1] - pt2 [1])) + abs(abs(pt1 [0] - pt2 [0]) - abs(pt1 [1] - pt2 [1]))
    if type == 4:
        return max(abs(pt1 [0] - pt2 [0]) , abs(pt1 [1] - pt2 [1]))


def f(l,c):
    d_deb = Distances[l,c]
    d_fin = heuristique ([l,c],[la,ca],2)
    return d_deb + d_fin

# Itérations

S = (ld,cd)
lS,cS = ld,cd
it = 0
from time import perf_counter as tps
t1 = tps()
while len(Reste) > 0 and S!=Arrivee and Distances[lS,cS]!=np.inf:
    it += 1
    # S ← Station parmi Reste ayant la distance minimum dans Distances
    Min = np.inf
    for s in Reste:
        l,c = s
        d = f(l,c) ###
        if d <= Min:
            Min = d
            S = s
    lS,cS = S
    # Mise à jour de Reste
    del Reste[S]
    '''
    # Affichage animation
    Image_Anim[lS,cS] = Rouge
    Chemin = "Animations/A star/"+str(it)+".png"
    Affiche_Save(22,Image_Anim,True,Chemin)
    #Affiche(22,Image_Anim,True)
    '''
    # Voisins ← Dico des stations de Reste voisines de S
    Voisins = Dico_Voisins[S]
    for V in Voisins:
        cle,_ = V
        if cle not in Reste.keys():
            Voisins.remove(V)
    # Traitement des voisins
    for V in Voisins:
        Case_v,dv = V
        lv,cv = Case_v
        D_S_V = Distances[lS,cS] + dv
        D_V = Distances[lv,cv]
        if D_S_V < D_V:
            Distances[lv,cv] = D_S_V
            Provenances[Case_v] = S
t2 = tps()
print('Temps: ',t2-t1)
print("Itérations: ",it)

# Traitement final C

Dst = Distances[la,ca]
print('Distance: ',Dst)

if Dst==np.inf:
    print("Pas de chemin possible")
else:
    p = Arrivee
    Chemin_Astar = [p]
    while p != Depart:
        p = Provenances[p]
        Chemin_Astar.append(p)
    Chemin_Astar.reverse()
    print(Chemin_Astar)

# Affichage du chemin

Image_Astar = Image.copy()
if Dst!=np.inf:
    Violet = [238,130,238]
    for Case in Chemin_Astar:
        l,c = Case
        Image_Astar[l,c] = Violet
        Image_Anim[l,c] = Violet # Si animation

Affiche(20,Image_Astar,False)
plt.savefig('Res_Solution_Astar.png')

'''
Chemin = "Animations/A star/"+str(it+1)+".png"
Affiche_Save(22,Image_Anim,True,Chemin)
'''

# Affichage des distances

Affiche_Degrade(21,Distances)
plt.savefig('Res_Distances_Astar.png')

## Comparaison des chemins Dijkstra Astar

if 'Chemin_Djk' in globals():
    Image_Djk_Astar = Image.copy()
    if Dst!=np.inf:
        Vert = [0,255,0]
        for Case in Chemin_Djk:
            l,c = Case
            Image_Djk_Astar[l,c] = Vert
        Violet = [238,130,238]
        for Case in Chemin_Astar:
            l,c = Case
            Image_Djk_Astar[l,c] = Violet
    Affiche(30,Image_Djk_Astar,False)
    plt.savefig('Res_Dijstra_Astar.png')